<?php
if (!defined('_PS_VERSION_')){
    exit;
}
class SwipePaymentModuleFrontController extends ModuleFrontController {

    private $responses = array(
        400 => "Access Denied - Swipe Checkout is configured Incorrectly",
        402 => "System Error - There was an error with the Swipe Checkout Servers",
        403 => "Not Enough Parameters - Swipe Checkout is configured Incorrectly",
        404 => "No results were found",
        407 => "Inactive Account  - Swipe Checkout account has been disabled"
    );
    
    public function initContent() {
        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {//Ensure cart loaded properly
            die("Cart Failed to load");
        }
        $item_summary = $cart->getSummaryDetails();
        $currencies = array();
        $transaction_currency = "";
        $currencies = $this->module->getCurrency();
        foreach($this->module->getCurrency() as $currency_array){
            if($currency_array['id_currency']==$cart->id_currency){
                $transaction_currency = strtolower($currency_array['iso_code']);
                break;
            }
        }
        $description = "";
        foreach($item_summary["products"] as $item){
            $description .= $item["cart_quantity"]."x"." ".$item["name"]; 
            if($item["attributes_small"] != ""){
                $description .= " - ".$item["attributes_small"];
            }
            $description .= "<br>";
        }
        $url = $this->module->apiUrl.'createTransactionIdentifier.php';
        $fields = array(
            'merchant_id' => $this->module->merchantId,
            'api_key' => $this->module->apiKey,
            'td_item' => " ",//Not displayed but required by API
            'td_amount' => $cart->getOrderTotal(),
            'td_description' => $description,
            'td_currency' => $transaction_currency,
            'td_user_data' => $cart->id." ".$cart->secure_key
        );
        
        $customer_email = $this->context->customer->email;
        if(!empty($customer_email)){
            $fields['td_email'] = $customer_email;
        }
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, count($fields));
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        $result = json_decode(curl_exec($ch), true);
        curl_close($ch);        
        
        if($result["response_code"] == 200){
            Tools::redirect($this->module->paymentPageUrl.'?checkout=true&identifier_id='.$result["data"]["identifier"]);
        }else{
            $message = $this->responses[$result["response_code"]];
            print "<p>There was an issue while redirecting to the secure Swipe HQ Checkout Page<p>";
            print "Error: <b>".$message."</b>";  
        }
    }
}
